/*
 * SSD1306 128x64に 16x16/16x8のフォントを表示
 * 
 */
#ifndef _OLED_H_
#define _OLED_H_
#include <arduino.h>
#include <Wire.h>
#include "KANJIROM.h"
#include "u2S.h"
#include "u2sTable.h"

class OLED
{
  private:
    int cursorX ;
    int cursorY ;
    uint8_t DisplayBuff[16*4] ;    // スクロール用キャラクラRAM領域

    U2S u2s ;
    KANJIROM kanjiRom ;

  public:
    void init(); // 初期化
    void cls(); // 画面クリア
    void dispSwitch(bool sw) ;
    void Print(char *str) { Print(str, false); }  // 文字列表示
    void Println(char *str) { Print(str, true); } // 文字列表示
    void PrintCR() ;

  protected:
    void clsOLED() ;
    void Print(char *str,bool flagCR); // 文字列表示
    void PrintASCII(uint8_t asciiCode,bool flagCR) ;
    void PrintSJIS(uint16_t sjisCode,bool flagCR) ;
    void scroll( ) ;
    void oledBitMap(int offsetX, int offsetY, int width, int hight, uint8_t *bitMap) ;
    void oledBitMap32(int col, int row, int width, uint8_t *bitMap) ;
    void oledSendCommand(uint8_t command); // OLEDに1バイトコマンドを送信
    void oledSendCommand2(uint8_t command1, uint8_t command2); // OLEDに2バイトコマンドを送信
    void oledSendCommand3(uint8_t command1, uint8_t command2,uint8_t command3); // OLEDに3バイトコマンドを送信
    void oledSendCommands(int commandLen, uint8_t commands[]); // OLEDに複数のコマンドを送信
} ;
#endif
